package com.hzya.frame.mdm.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.entity.MdmModuleDbFiledsRuleEntity;
import com.hzya.frame.mdm.mdmModuleDistribute.entity.MdmModuleDistributeEntity;
import com.hzya.frame.mdm.mdmModuleDistributeDetail.entity.MdmModuleDistributeDetailEntity;
import com.hzya.frame.mdm.mdmModuleSource.entity.MdmModuleSourceEntity;
import com.hzya.frame.mdm.mdmModuleView.entity.MdmModuleViewEntity;
import com.hzya.frame.mdm.mdmModuleViewButton.entity.MdmModuleViewButtonEntity;
import com.hzya.frame.mdm.mdmModuleViewDetail.entity.MdmModuleViewDetailEntity;
import com.hzya.frame.mdm.mdmTableCodeRule.entity.MdmTableCodeRuleEntity;
import com.hzya.frame.web.entity.JsonResultEntity;

import java.util.List;

/**
 * 主数据服务接口
 */
public interface IMdmServiceCache {


    /**
     * @Author lvleigang
     * @Description  获取模版主表
     * @Date 10:13 上午 2024/6/3
     * @param mdmCode
     * @return com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity
     **/
    MdmModuleEntity getMdmModuleEntity(Long mdmCode);
    /**
     * @Author lvleigang
     * @Description  获取模版单据编码规则
     * @Date 10:13 上午 2024/6/3
     * @param mdmTableCodeRuleEntity
     * @return com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity
     **/
    List<MdmTableCodeRuleEntity> queryMdmTableCodeRuleEntity(MdmTableCodeRuleEntity mdmTableCodeRuleEntity);
    /**
     * @Author lvleigang
     * @Description  获取模版表数据
     * @Date 10:13 上午 2024/6/3
     * @param queryDb
     * @return com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity
     **/
    List<MdmModuleDbEntity> queryMdmModuleDb(MdmModuleDbEntity queryDb);
    /**
     * @Author lvleigang
     * @Description  获取模版字段表数据
     * @Date 10:13 上午 2024/6/3
     * @param queryDbFiled
     * @return com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity
     **/
    List<MdmModuleDbFiledsEntity> queryMdmModuleDbFileds(MdmModuleDbFiledsEntity queryDbFiled);

    void updateMdmModuleEntity(MdmModuleEntity entity);


    List<MdmModuleDbFiledsRuleEntity> queryMdmModuleDbFiledsRule(MdmModuleDbFiledsRuleEntity queryDbFiledRule);

    void saveMdmTableCodeRule(String mdmid, List<MdmTableCodeRuleEntity> mdmTableCodeRuleEntities);

    void saveMdmModuleDb(String id, List<MdmModuleDbEntity> mdmModuleDbEntities);

    void saveMdmModuleDbFileds(String id, List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities);

    void saveMdmModuleDbFiledsRule(String id, List<MdmModuleDbFiledsRuleEntity> mdmModuleDbFiledsRuleEntities);

    List<MdmModuleViewDetailEntity> queryMdmModuleViewDetail(MdmModuleViewDetailEntity mdmModuleViewDetailEntity);

    List<MdmModuleViewEntity> queryMdmModuleView(MdmModuleViewEntity mdmModuleViewEntity);

    List<MdmModuleViewButtonEntity> queryMdmModuleViewButton(MdmModuleViewButtonEntity mdmModuleViewButtonEntity);

    void saveMdmModuleView(String id, MdmModuleViewEntity mdmModuleViewEntity);

    void saveMdmModuleViewDetail(String id, List<MdmModuleViewDetailEntity> mdmModuleViewDetailEntities);

    void saveMdmModuleViewButton(String id, List<MdmModuleViewButtonEntity> mdmModuleViewButtonEntities);

    List<MdmModuleDistributeEntity> queryMdmModuleDistribute(String id,MdmModuleDistributeEntity mdmModuleDistributeEntity);

    void saveMdmModuleDistribute(String id, List<MdmModuleDistributeEntity> mdmModuleDistributeEntities);

    List<MdmModuleSourceEntity> queryMdmModuleSource(MdmModuleSourceEntity mdmModuleSourceEntity);

    void saveMdmModuleSource(String id, List<MdmModuleSourceEntity> mdmModuleSourceEntities);

    List<MdmModuleDistributeDetailEntity> queryMdmModuleDistributeDetail(MdmModuleDistributeDetailEntity mdmModuleDistributeDetailEntity);
}
