package com.hzya.frame.sysnew.comparison.service.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.mdm.mdmModule.entity.MdmModuleEntity;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.service.impl.MdmServiceCache;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.sysnew.comparison.controlsLog.dao.impl.ControlsLogDaoImpl;
import com.hzya.frame.sysnew.comparison.dao.IComparisonDao;
import com.hzya.frame.sysnew.comparison.dao.IComparisonDetailsDao;
import com.hzya.frame.sysnew.comparison.entity.ComparisonDetailsEntity;
import com.hzya.frame.sysnew.comparison.entity.ComparisonEntity;
import com.hzya.frame.sysnew.comparison.service.IComparisonService;
import com.hzya.frame.uuid.UUIDUtils;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.collections.CollectionUtils;
import org.apache.ivy.Main;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import sun.java2d.pipe.AAShapePipe;

import java.util.*;

@Service(value = "comparisonServiceImpl")
public class ComparisonServiceImpl extends BaseService<ComparisonEntity, String> implements IComparisonService {

    private IComparisonDao comparisonDao;

    @Autowired
    private IComparisonDetailsDao comparisonDetailsDao;

    @Autowired
    private ControlsLogDaoImpl controlsLogDaoimpl;

    @Autowired
    private MdmServiceCache mdmServiceCache;

    @Autowired
    public void setGeneralDataDao(IComparisonDao dao) {
        this.comparisonDao = dao;
        this.dao = dao;
    }

    //分页查询通用数据数据
    @DS("master")
    @Override
    public JsonResultEntity queryEntityPage(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        if (jsonObject == null) {
            return BaseResult.getFailureMessageEntity("数据为空，请先传递数据");
        }
        if (!checkStr(jsonObject.getString("mdmCode"))) {
            return BaseResult.getFailureMessageEntity("主数据编码为空");
        }
        ComparisonEntity comparisonEntity = jsonObject.toJavaObject(ComparisonEntity.class);
        List<ComparisonEntity> comparisonEntities=new ArrayList<>();
        try {
            //根据主数据编码查询表名称，字段名称等信息 10001
            //comparisonEntities = comparisonDao.queryComparison(comparisonEntity);

            //comparisonEntities=getComparisonEntity(comparisonEntity);
            comparisonEntities=getComparisonEntityCache(comparisonEntity,"main");
        }catch (Exception e){
            logger.info("根据主数据编码查询信息错误:{}",e.getMessage());
            return BaseResult.getFailureMessageEntity("查询失败");
        }
        Map<String, Object> map = new HashMap<>();//将主表数据存到map中
        if (comparisonEntities != null && comparisonEntities.size() > 0) {
            for (ComparisonEntity entity : comparisonEntities) {
                //遍历主表下面的所有key,字段名
                for (String key : jsonObject.keySet()) {
                    if (entity.getDbType().equals("1")) {
                        comparisonEntity.setDbName(entity.getDbName());
                        if(!"mdmCode".equals(key)){
                            map.put(key, jsonObject.getString(key));
                            map.remove("appName");
                            map.remove("appCode");
                        }
                    }
                }
            }
            comparisonEntity.setMap(map);
            try {
                List<Map<String,Object>> comparisonEntitiePages = comparisonDao.queryComparisonPage(comparisonEntity);
                PageInfo pageInfo = new PageInfo(comparisonEntitiePages);
                return BaseResult.getSuccessMessageEntity("查询成功", pageInfo);
            } catch (Exception e) {
                logger.info("查询通用数据错误:{}", e.getMessage());
                return BaseResult.getFailureMessageEntity("查询失败");
            }
        }
        return BaseResult.getFailureMessageEntity("查询失败","请检查传递参数");
    }

    //新增通用数据数据
    @DS("master")
    @Override
    public JsonResultEntity saveEntity(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        if (jsonObject == null) {
            return BaseResult.getFailureMessageEntity("数据为空，请先传递数据");
        }
        if (!checkStr(jsonObject.getString("mdmCode"))) {
            return BaseResult.getFailureMessageEntity("主数据编码为空");
        }
        if (!checkStr(jsonObject.getString("optionName"))) {
            return BaseResult.getFailureMessageEntity("操作人为空");
        }
        /*if (!checkStr(jsonObject.getString("rulePrefix"))) {
            return BaseResult.getFailureMessageEntity("规则为空");
        }*/
        ComparisonEntity comparisonEntity = jsonObject.toJavaObject(ComparisonEntity.class);
        ComparisonDetailsEntity comparisonDetailsEntity=new ComparisonDetailsEntity();
            List<ComparisonEntity> comparisonEntities=new ArrayList<>();
            try {
                //根据主数据编码查询表名称，字段名称等信息 10001
                // comparisonEntities = comparisonDao.queryComparison(comparisonEntity);

                //comparisonEntities=getComparisonEntity(comparisonEntity);
                comparisonEntities=getComparisonEntityCache(comparisonEntity,"main");
            }catch (Exception e){
                logger.info("根据主数据编码查询信息错误:{}",e.getMessage());
                return BaseResult.getFailureMessageEntity("保存失败");
            }
            String main = jsonObject.getString("main");//获取主表数据
            JSONArray jsonArray = jsonObject.getJSONArray("details");//获取子表数据
            JSONObject jsonObjectMain = JSONObject.parseObject(main);
            if(jsonObjectMain != null ) {
                Map<String, Object> map = new HashMap<>();//将主表数据存到map中
                Map<String, Object> mapDetails = new HashMap<>();//将子表数据存到map中
                if (comparisonEntities != null && comparisonEntities.size() > 0) {
                    map=spliceMainMap(comparisonEntities,jsonObjectMain,map,comparisonEntity);
                    mapDetails=spliceDetailMap(comparisonEntities,mapDetails,comparisonDetailsEntity,jsonArray);
                    String uuid=null;
                    if(jsonObjectMain.getString("id")==null){
                        uuid = UUIDUtils.getUUID();
                        map.put("id", uuid);
                    }else{
                        uuid = jsonObjectMain.getString("id");
                        map.put("id", jsonObjectMain.getString("id"));
                    }
                    map.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                    map.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                    map.put("org_id", "0");
                    map.put("create_time", new Date());
                    map.put("modify_time", new Date());
                    map.put("sts", "Y");
                    map.put("data_status","Y");//新增状态
                    map.put("add_status","0");//新增状态
                    map.put("update_status","1");//修改状态
                    map.put("delete_status","1");//删除状态
                    ComparisonEntity comparisonEntityRule = comparisonEntities.get(0);
                    //查询单据规则
                    try {
                          comparisonEntityRule= comparisonDao.queryComparisonById(comparisonEntityRule);
                         String documentRule =comparisonEntityRule.getDocumentRule();;         //"KH-2024-05-30-1";
                        logger.info("通用数据保存接口中根据mId查询出来的单据规则为:{}",documentRule);
                        if(documentRule !=null){
                            //获取规则前缀 CK
                            String rulePrefix=documentRule.substring(0,documentRule.indexOf("-"));
                            //获取规则中间日期 yyyy-MM-dd
                            String ruleDate = documentRule.substring(documentRule.indexOf("-") + 1, documentRule.lastIndexOf("-"));
                            String ruleMiddle = getRuleDate(ruleDate);
                            //获取规则后缀
                            String ruleSuffixLength= documentRule.substring(documentRule.lastIndexOf("-")+1);
                            int ruleSuffix = ruleSuffixLength.length();
                            //生成单据规则
                            comparisonEntity.setRulePrefix(rulePrefix);
                            comparisonEntity.setRuleMiddle(ruleMiddle);
                            comparisonEntity.setRuleSuffix(ruleSuffix);
                            try {
                                //新生成单据规则保存到数据库
                                comparisonEntityRule = comparisonDao.queryComparisonRule(comparisonEntity);
                                map.put("document_rule", comparisonEntityRule.getDocumentRule());//单据规则
                                map.put("document_rule_num", comparisonEntityRule.getDocumentRuleNum());//单据规则流水号
                                comparisonEntity.setMap(map);
                            } catch (Exception e) {
                                logger.info("保存通用数据时候生成单据规则错误:{}", e.getMessage());
                                return BaseResult.getFailureMessageEntity("保存失败");
                            }
                        }
                    }catch (Exception e){
                        logger.info("通用数据保存接口中查询单据规则错误:{}",e.getMessage());
                        return BaseResult.getFailureMessageEntity("保存失败");
                    }
                    try {
                        //保存主表数据
                        ComparisonEntity comparisonEntityOne = comparisonDao.saveComparison(comparisonEntity);
                        //保存子表数据
                        if (mapDetails != null && mapDetails.size() > 0) {
                            String uuidDetail = UUIDUtils.getUUID();
                            mapDetails.put("id", uuidDetail);
                            mapDetails.put("formmain_id", uuid);
                            mapDetails.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                            mapDetails.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                            mapDetails.put("org_id", "0");
                            mapDetails.put("create_time", new Date());
                            mapDetails.put("modify_time", new Date());
                            mapDetails.put("sts", "Y");
                            mapDetails.put("data_status","Y");//新增状态
                            comparisonDetailsEntity.setMapDetails(mapDetails);
                            ComparisonDetailsEntity comparisonDetailsEntityOne = comparisonDetailsDao.saveComparisonDetails(comparisonDetailsEntity);
                            //comparisonEntityOne.setComparisonDetailsEntity(comparisonDetailsEntityOne);
                            map.put("details",mapDetails);
                            //保存操作日志
                            controlsLogDaoimpl.saveControlsLog(uuidDetail,jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口新增",jsonObject.getString("optionName"),comparisonDetailsEntity.getDbName()+"_option_log");
                        }
                        //保存操作日志
                        controlsLogDaoimpl.saveControlsLog(uuid,jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口新增",jsonObject.getString("optionName"),comparisonEntity.getDbName()+"_option_log");
                        return BaseResult.getSuccessMessageEntity("保存成功", map);
                    } catch (Exception e) {
                        logger.info("保存通用数据时候错误:{}", e.getMessage());
                        return BaseResult.getFailureMessageEntity("保存失败");
                    }
                }
            }
        return BaseResult.getFailureMessageEntity("查询失败","请检查传递参数");
    }

    //更新通用数据数据
    @Override
    public JsonResultEntity updateEntity(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        if (jsonObject == null) {
            return BaseResult.getFailureMessageEntity("数据为空，请先传递数据");
        }
        if (!checkStr(jsonObject.getString("mdmCode"))) {
            return BaseResult.getFailureMessageEntity("主数据编码为空");
        }
        if (!checkStr(jsonObject.getString("optionName"))) {
            return BaseResult.getFailureMessageEntity("操作人为空");
        }
        ComparisonEntity comparisonEntity = jsonObject.toJavaObject(ComparisonEntity.class);
        ComparisonDetailsEntity comparisonDetailsEntity=new ComparisonDetailsEntity();
        JSONObject jsonObjectMain=jsonObject.getJSONObject("main");//获取主表数据
        JSONArray jsonArray = jsonObject.getJSONArray("details");//获取子表数据
        if(!checkStr(jsonObjectMain.getString("id"))){
            return BaseResult.getFailureMessageEntity("更新时候主表id不能为空");
        }
        List<ComparisonEntity> comparisonEntities=new ArrayList<>();
        //根据主数据编码查询表名称，字段名称等信息 10001
        try {
           // comparisonEntities = comparisonDao.queryComparison(comparisonEntity);

            //comparisonEntities=getComparisonEntity(comparisonEntity);
            comparisonEntities=getComparisonEntityCache(comparisonEntity,"main");
        }catch (Exception e){
            logger.info("根据主数据编码查询信息错误:{}",e.getMessage());
            return BaseResult.getFailureMessageEntity("更新失败");
        }
        Map<String,Object> map=new HashMap<>();//将主表数据存到map中
        Map<String,Object> mapDetails=new HashMap<>();//将子表数据存到map中
        if(comparisonEntities !=null && comparisonEntities.size()>0) {
            map=spliceMainMap(comparisonEntities,jsonObjectMain,map,comparisonEntity);
            mapDetails=spliceDetailMap(comparisonEntities,mapDetails,comparisonDetailsEntity,jsonArray);
            map.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
            map.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
            map.put("org_id", "0");
            map.put("modify_time", new Date());
            map.put("sts", "Y");
            map.put("data_status","F");//数据状态
            map.put("update_status","0");//修改状态
            comparisonEntity.setMap(map);
            comparisonEntity.setId(jsonObjectMain.getString("id"));
        /*//生成单据规则
        comparisonEntity.setRulePrefix(jsonObject.getString("rulePrefix"));
        try {
            ComparisonEntity comparisonEntityRule = comparisonDao.queryComparisonRule(comparisonEntity);
            map.put("document_rule",comparisonEntityRule.getDocumentRule());//单据规则
            map.put("document_rule_num",comparisonEntityRule.getDocumentRuleNum());//单据规则流水号
        }catch (Exception e){
            logger.info("更新通用数据时候生成单据规则错误:{}",e.getMessage());
            return BaseResult.getFailureMessageEntity("更新失败",e.getMessage());
        }*/
            try {
                //保存主表数据
                Integer integer = comparisonDao.updateComparisonByType(comparisonEntity);
                if (integer > 0) {
                    //保存子表数据
                    if (mapDetails != null && mapDetails.size() > 0) {
                        mapDetails.put("create_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                        mapDetails.put("modify_user_id", "c796fd9ba4c9f5ff3cc2fa41a040e443");
                        mapDetails.put("org_id", "0");
                        mapDetails.put("modify_time", new Date());
                        mapDetails.put("sts", "Y");
                        mapDetails.put("data_status","F");//数据状态
                        comparisonDetailsEntity.setFormmainId(jsonObjectMain.getString("id"));
                        comparisonDetailsEntity.setMapDetails(mapDetails);
                        comparisonDetailsDao.updateComparisonDetailsByType(comparisonDetailsEntity);
                        //保存操作日志
                        controlsLogDaoimpl.saveControlsLog(comparisonDetailsEntity.getId(),jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口更新",jsonObject.getString("optionName"),comparisonDetailsEntity.getDbName()+"_option_log");
                    }
                    //保存操作日志
                    controlsLogDaoimpl.saveControlsLog(comparisonEntity.getId(),jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口更新",jsonObject.getString("optionName"),comparisonEntity.getDbName()+"_option_log");
                    return BaseResult.getSuccessMessageEntity("更新成功", integer);
                }else{
                    return BaseResult.getFailureMessageEntity("更新失败");
                }
            } catch (Exception e) {
                logger.info("更新通用数据时候错误:{}", e.getMessage());
                return BaseResult.getFailureMessageEntity("更新失败");
            }
        }
        return BaseResult.getFailureMessageEntity("查询失败","请检查传递参数");
    }

    //删除通用数据
    @Override
    public JsonResultEntity deleteEntity(JSONObject json) {
        JSONObject jsonObject = json.getJSONObject("jsonStr");
        if (jsonObject == null) {
            return BaseResult.getFailureMessageEntity("数据为空，请先传递数据");
        }
        if (!checkStr(jsonObject.getString("mdmCode"))) {
            return BaseResult.getFailureMessageEntity("主数据编码为空");
        }
        if (!checkStr(jsonObject.getString("optionName"))) {
            return BaseResult.getFailureMessageEntity("操作人为空");
        }
        ComparisonEntity comparisonEntity = jsonObject.toJavaObject(ComparisonEntity.class);
        ComparisonDetailsEntity comparisonDetailsEntity=new ComparisonDetailsEntity();
        JSONObject jsonObjectMain=jsonObject.getJSONObject("main");//获取主表数据
        if(!checkStr(jsonObjectMain.getString("id"))){
            return BaseResult.getFailureMessageEntity("删除时候主表id不能为空");
        }
        List<ComparisonEntity> comparisonEntities=new ArrayList<>();
        //根据主数据编码查询表名称，字段名称等信息 10001
        try {
           // comparisonEntities = comparisonDao.queryComparison(comparisonEntity);

            //comparisonEntities=getComparisonEntity(comparisonEntity);
            comparisonEntities=getComparisonEntityCache(comparisonEntity,"main");
        }catch (Exception e){
            logger.info("根据主数据编码查询信息错误:{}",e.getMessage());
            return BaseResult.getFailureMessageEntity("删除失败");
        }
        Map<String,Object> map=new HashMap<>();
        if(comparisonEntities !=null && comparisonEntities.size()>0) {
            for (ComparisonEntity entity : comparisonEntities) {
                //遍历主表下面的所有key,字段名
                for (String key : jsonObjectMain.keySet()) {
                    if (entity.getDbType().equals("1")) {
                        comparisonEntity.setDbName(entity.getDbName());
                        if(entity.getEnName().equals(key)){
                            map.put(key, jsonObjectMain.getString(key));
                        }
                    }
                    if(entity.getDbType().equals("2")){
                        comparisonDetailsEntity.setDbName(entity.getDbName());
                    }
                }
            }
            comparisonEntity.setId(jsonObjectMain.getString("id"));
            comparisonEntity.setModify_user_id("c796fd9ba4c9f5ff3cc2fa41a040e443");
            comparisonEntity.setMap(map);
            try {
                Integer integer = comparisonDao.deleteComparison(comparisonEntity);
                if(integer>0){
                    if(comparisonDetailsEntity.getDbName()!=null){
                        comparisonDetailsEntity.setFormmainId(jsonObjectMain.getString("id"));
                        comparisonDetailsEntity.setModify_user_id("c796fd9ba4c9f5ff3cc2fa41a040e443");
                        comparisonDetailsDao.deleteComparisonDetails(comparisonDetailsEntity);
                        controlsLogDaoimpl.saveControlsLog(comparisonDetailsEntity.getId(),jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口删除",jsonObject.getString("optionName"),comparisonEntity.getDbName()+"_option_log");
                    }
                    controlsLogDaoimpl.saveControlsLog(comparisonEntity.getId(),jsonObject.getString("appName"),jsonObject.getString("appCode"),jsonObject.toJSONString(),"接口删除",jsonObject.getString("optionName"),comparisonEntity.getDbName()+"_option_log");
                     return BaseResult.getSuccessMessageEntity("删除成功",integer);
                }else{
                    return BaseResult.getFailureMessageEntity("删除失败","请查看id是否在表中存在");
                }
            }catch (Exception e){
                logger.info("删除通用数据数据错误:{}",e.getMessage());
                return BaseResult.getFailureMessageEntity("删除失败");
            }
        }
        return BaseResult.getFailureMessageEntity("查询失败","请检查传递参数");
    }

    //根据应用key和应用密钥获取应用编码和应用名称
    @Override
    public SysExtensionApiEntity getAppNameAndCode(SysExtensionApiEntity sysExtensionApiEntity) {
        String bodys = sysExtensionApiEntity.getBodys();
        SysApplicationEntity sendApp = sysExtensionApiEntity.getSendApp();
        JSONObject jsonObject = JSON.parseObject(bodys);
        jsonObject.put("appName",sendApp.getName());
        jsonObject.put("appCode",sendApp.getAppId());
        sysExtensionApiEntity.setBodys(jsonObject.toJSONString());
        return sysExtensionApiEntity;
    }

    //根据不同的日期格式，返回不同的值
    private String getRuleDate(String str){
        switch (str){
            case "yyyy-MM-dd":
                return "%Y-%m-%d";
            case "yyyyMMdd":
                return "%Y%m%d";
            case "yyyy-MM-dd HH:mm:ss":
                return "Y-%m-%d %H:%i:%s";
            case "yyyyMMddHHmmss":
                return "%Y%m%d%H%i%s";
            case "yyyyMMddHHmmssSSS":
                return "%Y%m%d%H%i%s%f";
            default:
                return null;
        }
    }

    //得到主表数据
    private Map<String,Object> spliceMainMap(List<ComparisonEntity> comparisonEntities,JSONObject jsonObjectMain,Map<String, Object> map,ComparisonEntity comparisonEntity){
        for (ComparisonEntity entity : comparisonEntities) {
            //遍历主表下面的所有key,字段名
            for (String key : jsonObjectMain.keySet()) {
                if (entity.getDbType().equals("1")) {
                    comparisonEntity.setDbName(entity.getDbName());
                    //如果表中得字段与输入得字段相等，则存起来
                    if(entity.getEnName().equals(key)){
                        map.put(key, jsonObjectMain.getString(key));
                    }
                }
            }
        }
        return map;
    }

    //得到明细表数据
    private Map<String,Object> spliceDetailMap(List<ComparisonEntity> comparisonEntities,Map<String, Object> mapDetails,ComparisonDetailsEntity comparisonDetailsEntity,JSONArray jsonArray){
        if (jsonArray != null && jsonArray.size() > 0) {
            for (Object object : jsonArray) {
                JSONObject jsonObjectDetails = (JSONObject) JSON.toJSON(object);
                for (ComparisonEntity entity : comparisonEntities) {
                    //遍历主表下面的所有key,字段名
                    for (String key : jsonObjectDetails.keySet()) {
                        if (entity.getDbType().equals("2")) {
                            comparisonDetailsEntity.setDbName(entity.getDbName());
                            if(entity.getEnName().equals(key)){
                                mapDetails.put(key, jsonObjectDetails.getString(key));
                            }
                        }
                    }
                }
            }
        }
        return mapDetails;
    }

    //根据主数据编码获取主表和明细表表名称，表字段信息
    public List<ComparisonEntity> getComparisonEntityCache(ComparisonEntity comparison,String type){
        List<ComparisonEntity> comparisonEntities = new ArrayList<>();
        //根据主数据编号获取模板主表
        MdmModuleEntity mdmModuleEntity = mdmServiceCache.getMdmModuleEntity(Long.valueOf(comparison.getMdmCode()));
        //根据模板主表id获取模版表数据
        if(mdmModuleEntity!=null){
            MdmModuleDbEntity mdmModuleDbEntity = new MdmModuleDbEntity();
            mdmModuleDbEntity.setMdmId(mdmModuleEntity.getId());
            List<MdmModuleDbEntity> mdmModuleDbEntities = mdmServiceCache.queryMdmModuleDb(mdmModuleDbEntity);
            if(CollectionUtils.isNotEmpty(mdmModuleDbEntities)){
                for (MdmModuleDbEntity moduleDbEntity : mdmModuleDbEntities) {
                    switch (type){
                        case "main":
                            //获取主表和明细表的字段信息
                            if(moduleDbEntity.getDbType().equals("1") || moduleDbEntity.getDbType().equals("2")){
                                MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity=new MdmModuleDbFiledsEntity();
                                mdmModuleDbFiledsEntity.setMdmId(mdmModuleEntity.getId());
                                List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
                                if(CollectionUtils.isNotEmpty(mdmModuleDbFiledsEntities)){
                                    for (MdmModuleDbFiledsEntity moduleDbFiledsEntity : mdmModuleDbFiledsEntities) {
                                        if (moduleDbFiledsEntity.getDbId().equals(moduleDbEntity.getId())) {
                                            ComparisonEntity comparisonEntityFile = new ComparisonEntity();
                                            comparisonEntityFile.setChName(moduleDbFiledsEntity.getChName());
                                            comparisonEntityFile.setEnName(moduleDbFiledsEntity.getEnName());
                                            comparisonEntityFile.setFiledType(moduleDbFiledsEntity.getFiledType());
                                            comparisonEntityFile.setAddType(moduleDbFiledsEntity.getAddType());
                                            comparisonEntityFile.setUpdateType(moduleDbFiledsEntity.getUpdateType());
                                            comparisonEntityFile.setShowType(moduleDbFiledsEntity.getShowType());
                                            comparisonEntityFile.setQueryType(moduleDbFiledsEntity.getQueryType());
                                            comparisonEntityFile.setListType(moduleDbFiledsEntity.getListType());
                                            comparisonEntityFile.setViewType(moduleDbFiledsEntity.getViewType());
                                            comparisonEntityFile.setDbName(moduleDbEntity.getDbName());
                                            comparisonEntityFile.setDbType(moduleDbEntity.getDbType());
                                            comparisonEntityFile.setDbId(moduleDbEntity.getId());
                                            comparisonEntityFile.setmId(mdmModuleEntity.getId());
                                            comparisonEntityFile.setMdmName(mdmModuleEntity.getMdmName());
                                            comparisonEntityFile.setMdmCode(String.valueOf(mdmModuleEntity.getMdmCode()));
                                            comparisonEntities.add(comparisonEntityFile);
                                        }
                                    }
                                }
                            }
                            break;
                        case "option":
                            //获取主表和明细表的字段信息
                            if(moduleDbEntity.getDbType().equals("3")){
                                MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity=new MdmModuleDbFiledsEntity();
                                mdmModuleDbFiledsEntity.setDbId(moduleDbEntity.getId());
                                List<MdmModuleDbFiledsEntity> mdmModuleDbFiledsEntities = mdmServiceCache.queryMdmModuleDbFileds(mdmModuleDbFiledsEntity);
                                if(CollectionUtils.isNotEmpty(mdmModuleDbFiledsEntities)){
                                    for (MdmModuleDbFiledsEntity moduleDbFiledsEntity : mdmModuleDbFiledsEntities) {
                                        if (moduleDbFiledsEntity.getDbId().equals(moduleDbEntity.getId())) {
                                            ComparisonEntity comparisonEntityFile = new ComparisonEntity();
                                            comparisonEntityFile.setChName(moduleDbFiledsEntity.getChName());
                                            comparisonEntityFile.setEnName(moduleDbFiledsEntity.getEnName());
                                            comparisonEntityFile.setFiledType(moduleDbFiledsEntity.getFiledType());
                                            comparisonEntityFile.setAddType(moduleDbFiledsEntity.getAddType());
                                            comparisonEntityFile.setUpdateType(moduleDbFiledsEntity.getUpdateType());
                                            comparisonEntityFile.setShowType(moduleDbFiledsEntity.getShowType());
                                            comparisonEntityFile.setQueryType(moduleDbFiledsEntity.getQueryType());
                                            comparisonEntityFile.setListType(moduleDbFiledsEntity.getListType());
                                            comparisonEntityFile.setViewType(moduleDbFiledsEntity.getViewType());
                                            comparisonEntityFile.setDbName(moduleDbEntity.getDbName());
                                            comparisonEntityFile.setDbType(moduleDbEntity.getDbType());
                                            comparisonEntityFile.setDbId(moduleDbEntity.getId());
                                            comparisonEntityFile.setmId(mdmModuleEntity.getId());
                                            comparisonEntityFile.setMdmName(mdmModuleEntity.getMdmName());
                                            comparisonEntityFile.setMdmCode(String.valueOf(mdmModuleEntity.getMdmCode()));
                                            comparisonEntities.add(comparisonEntityFile);
                                        }
                                    }
                                }
                            }
                            break;
                        default:
                            break;
                    }

                }
            }
            return comparisonEntities;
        }
        return null;
    }

    //根据主数据编码获取数据，表名称，字段名称等
    public List<ComparisonEntity> getComparisonEntity(ComparisonEntity comparisonEntity) {
        List<ComparisonEntity> comparisonEntities = new ArrayList<>();
        //根据主数据编码查询mdm_module数据
        ComparisonEntity comparisonEntityModule = comparisonDao.queryComparisonBymdmCode(comparisonEntity);
        if (comparisonEntityModule != null) {
            //根据mdm_module得id查询mdm_module_db得数据
            List<ComparisonEntity> comparisonEntitiesModuleDb = comparisonDao.queryComparisonBymdmId(comparisonEntityModule);
            if(CollectionUtils.isNotEmpty(comparisonEntitiesModuleDb)) {
                for (ComparisonEntity comparison : comparisonEntitiesModuleDb) {
                    //查询出主表和明细表信息
                    if(comparison.getDbType().equals("1")||comparison.getDbType().equals("2")) {
                        //根据mdm_module_db的id查询对应表的字段
                        List<ComparisonEntity> comparisonEntitiesFiles = comparisonDao.queryComparisonBymdmIdFileds(comparison);
                        if (CollectionUtils.isNotEmpty(comparisonEntitiesFiles)) {
                            for (ComparisonEntity comparisonEntitiesFile : comparisonEntitiesFiles) {
                                ComparisonEntity comparisonEntityFile = new ComparisonEntity();
                                comparisonEntityFile.setChName(comparisonEntitiesFile.getChName());
                                comparisonEntityFile.setEnName(comparisonEntitiesFile.getEnName());
                                comparisonEntityFile.setFiledType(comparisonEntitiesFile.getFiledType());
                                comparisonEntityFile.setAddType(comparisonEntitiesFile.getAddType());
                                comparisonEntityFile.setUpdateType(comparisonEntitiesFile.getUpdateType());
                                comparisonEntityFile.setShowType(comparisonEntitiesFile.getShowType());
                                comparisonEntityFile.setQueryType(comparisonEntitiesFile.getQueryType());
                                comparisonEntityFile.setListType(comparisonEntitiesFile.getListType());
                                comparisonEntityFile.setViewType(comparisonEntitiesFile.getViewType());
                                comparisonEntityFile.setDbName(comparison.getDbName());
                                comparisonEntityFile.setDbType(comparison.getDbType());
                                comparisonEntityFile.setDbId(comparison.getDbId());
                                comparisonEntityFile.setmId(comparisonEntitiesFile.getmId());
                                comparisonEntityFile.setMdmName(comparisonEntityModule.getMdmName());
                                comparisonEntityFile.setMdmCode(comparisonEntityModule.getMdmCode());
                                comparisonEntities.add(comparisonEntityFile);
                            }
                        }
                    }
                }
            }

           /* //根据mdm_module得id查询mdm_module_db_fileds得数据
            List<ComparisonEntity> comparisonEntitiesFiles = comparisonDao.queryComparisonBymdmIdFileds(comparisonEntityModule);
            for (ComparisonEntity comparison : comparisonEntitiesModuleDb) {
                for (ComparisonEntity comparisonEntitiesFile : comparisonEntitiesFiles) {
                    if(comparison.getDbId().equals(comparisonEntitiesFile.getDbId())){
                        ComparisonEntity comparisonEntityFile=new ComparisonEntity();
                        comparisonEntityFile.setChName(comparisonEntitiesFile.getChName());
                        comparisonEntityFile.setEnName(comparisonEntitiesFile.getEnName());
                        comparisonEntityFile.setFiledType(comparisonEntitiesFile.getFiledType());
                        comparisonEntityFile.setAddType(comparisonEntitiesFile.getAddType());
                        comparisonEntityFile.setUpdateType(comparisonEntitiesFile.getUpdateType());
                        comparisonEntityFile.setShowType(comparisonEntitiesFile.getShowType());
                        comparisonEntityFile.setQueryType(comparisonEntitiesFile.getQueryType());
                        comparisonEntityFile.setListType(comparisonEntitiesFile.getListType());
                        comparisonEntityFile.setViewType(comparisonEntitiesFile.getViewType());
                        comparisonEntityFile.setDbName(comparison.getDbName());
                        comparisonEntityFile.setDbType(comparison.getDbType());
                        comparisonEntityFile.setDbId(comparison.getDbId());
                        comparisonEntityFile.setmId(comparisonEntitiesFile.getmId());
                        comparisonEntityFile.setMdmName(comparisonEntityModule.getMdmName());
                        comparisonEntityFile.setMdmCode(comparisonEntityModule.getMdmCode());
                        comparisonEntities.add(comparisonEntityFile);
                    }
                }
            }*/
            return comparisonEntities;
        }
        return null;
    }

}
